import AnimTestUI_Generate from "./ui-generate/AnimTestUI_generate";

export class AnimTestUI extends AnimTestUI_Generate {
    private animObj = null
    protected async onStart() {
        const character = Player.localPlayer.character;

        const animAssetId = "8354";
        let anim: Animation = null;

        await AssetUtil.asyncDownloadAsset(animAssetId)
        this.mStartFullAnim.onClicked.add(() => {
            // 全身动画
            anim = character.loadAnimation(animAssetId);
            anim.slot = AnimSlot.FullyBody;
            anim.play();
        });
        this.mStartUpperAnim.onClicked.add(() => {
            // 上身动画
            anim = character.loadAnimation(animAssetId)
            anim.slot = AnimSlot.Upper
            anim.speed = 0.2;
            anim.play()
        });
        this.mStartLowerAnim.onClicked.add(() => {
            // 下身动画
            anim = character.loadAnimation(animAssetId);
            anim.slot = AnimSlot.Lower;
            anim.play();
        });
        this.mStopAnim.onClicked.add(() => {
            // 停止动画
            const result = anim.stop();
            console.log("停止结果", result);

        });


        const assetId = "94258";
        await AssetUtil.asyncDownloadAsset(assetId);

        this.mStartFullStance.onClicked.add(async () => {
            // 全身姿态
            const stance = character.loadSubStance(assetId)
            stance.blendMode = StanceBlendMode.WholeBody;
            stance.play();
        });
        this.mStartUpperStance.onClicked.add(async () => {
            // 上身姿态
            const stance = character.loadSubStance(assetId)
            stance.blendMode = StanceBlendMode.BlendUpper;
            stance.play();
        });
        this.mStartLowerStance.onClicked.add(async () => {
            // 下身姿态
            const stance = character.loadSubStance(assetId)
            stance.blendMode = StanceBlendMode.BlendLower;
            stance.play();
        });
        this.mStopStance.onClicked.add(() => {
            // 停止姿态
            if (character.currentStance) {
                character.currentStance.stop();
            }
        });
        this.mStartBasicStance1.onClicked.add(() => {
            // 基础姿态1
            character.loadStance("39317");
        });
        this.mStartBasicStance2.onClicked.add(() => {
            // 基础姿态2
            character.loadStance("119837");
        });
        this.mStartBasicStance3.onClicked.add(() => {
            // 基础姿态3
            character.loadStance("154704");
        });
        this.mResetBasicStance.onClicked.add(() => {
            // 默认基础姿态
            character.loadStance("30274");
        });
    }
}