﻿import { AnimTestUI } from "./AnimTestUI";

@Component
export default class AnimationControl extends Script {

    /** 当脚本被实例后，会在第一帧更新前调用此函数 */
    protected async onStart(): Promise<void> {
        if (SystemUtil.isClient()) {
            UIService.show(AnimTestUI);
        }

        if (SystemUtil.isClient()) {

            // // ====== 演示更换基础姿态的代码 START =======
            // 设置基础姿态为119836(写实-男性-基础姿态)
            // Player.localPlayer.character.loadStance("119836");
            // // ====== 演示更换基础姿态的代码 END =======


            // ====== 演示更换二级姿态的代码 START =======
            // 定义一个放姿态guid的变量，后面引用
            const stanceGuid = "8362";
            // 因为姿态是属于资源类型，在远程资源库中，所以使用前先下载资源到本地(await关键词的作用就是等待资源下载完成后再执行后面的代码)
            await AssetUtil.asyncDownloadAsset(stanceGuid);
            // 使用角色的加载姿态接口，将姿态资源信息给角色对象, 生成姿态对象来控制
            const subStance = Player.localPlayer.character.loadSubStance(stanceGuid);
            // 设置姿态播放模式为全身播放(StanceBlendMode中有全身、上半身、下半身三种播放模式）
            subStance.blendMode = StanceBlendMode.BlendUpper;
            // 使用姿态对象调用播放接口
            subStance.play()
            // ====== 演示更换二级姿态的代码 END =======

            // ====== 演示播放动画的代码 START =======
            setTimeout(async () => {
                const animId = "14497";
                // 下载动画资源
                await AssetUtil.asyncDownloadAsset(animId);
                // 加载动画对象
                const anim = Player.localPlayer.character.loadAnimation(animId);
                // 设置动画播放为全身（要注意和姿态的接口不一样）
                anim.slot = AnimSlot.Lower;
                // 播放动画
                anim.play()
            }, 5000);
            // ====== 演示播放动画的代码 END =======

        }
    }
}